# Server Manager release 1.0.0 by Steven Hartin
# ./addons/eventscripts/server_manager/server_manager.py

# >>> To configure this addon please see prefix_manager.cfg <<<

#################################
#### DO NOT EDIT THIS FILE, #####
####    IF YOU DO, THINGS   #####
####   THINGS COULD BREAK   #####
#################################

# Import modules
import es
import os
import gamethread

# psyco, more unstable but a lot faster
import psyco
psyco.full() 

# Set the addon info data
info = es.AddonInfo()
info.name = 'Server Manager'
info.version = '1.0.0'
info.url = 'http://addons.eventscripts.com/addons/view/server_manager'
info.basename = 'server_manager'
info.author = 'Freddukes AKA Pro Noob'

es.ServerVar('server_manager', info.version, 'The current version of server_manager by freddukes').makepublic()

def load():
    """Called upon mod load. Execute the prefix manager.cfg"""
    if os.path.isfile(es.getAddonPath('server_manager') + '/prefix_manager.cfg'):
        es.server.queuecmd('es_xmexec ../addons/eventscripts/server_manager/prefix_manager.cfg')
        
prefixDict = {}
    
def server(ev):
    """Called a gameframe before the server.cfg is loaded. Execute all 'start' configs here."""
    thismap = str(es.ServerVar('eventscripts_currentmap'))
    thisprefix = ""
    for instance in prefixDict:
        if thismap.startswith(instance):
            thisprefix = instance
            break
    if prefixDict.has_key(thisprefix):
        for config in prefixDict[thisprefix].prefix['config']:
            if prefixDict[thisprefix].prefix['config'][config] == "start":
                gamethread.delayed(2, es.server.queuecmd, 'es_xmexec %s' % config)
    
def est_map_end(ev):
    """Called before the map ends. Execute any 'end' configs here, and unload the
       current scripts assosiated with that map type, and load the new ones."""
    thismap = ev['thismap']
    nextmap = ev['nextmap']
    thisprefix = ""
    nextprefix = ""
    for instance in prefixDict:
        if thismap.startswith(instance):
            thisprefix = instance
        if nextmap.startswith(instance):
            nextprefix = instance   
    if not thisprefix == nextprefix:
        if prefixDict.has_key(thisprefix):
            for script in prefixDict[thisprefix].prefix['scripts']:
                es.unload(script)
            for config in prefixDict[thisprefix].prefix['config']:
                if prefixDict[thisprefix].prefix['config'] == "end":
                    es.server.queuecmd('es_xmexec %s'%config)
        if prefixDict.has_key(nextprefix):
            for script in prefixDict[nextprefix].prefix['scripts']:
                es.load(script)
            
    
def initializeManager():
    """Called upon command addprefix. Check how many args is in here and do the relevant tasks."""
    prefix = es.getargv(1)
    prefixDict[prefix] = scriptManager(prefix.lower())
    if es.getargc() > 2:
        # More than the prefix alone
        if not es.getargv(2).isdigit():
            # If the second arg is not a 0 (I.E it's a script list...)
            addScript(prefix, es.getargv(2))
        if es.getargc() > 3:
            # If there are more than 3 args
            if es.getargc() == 6:
                # If arguments is equal to 6 then they've turned the option False to load from ../cfg/
                if es.getargv(5).isdigit():
                    addConfig(prefix, es.getargv(3), es.getargv(4), False)
            else:
                # Else if the argument is 5, then they've not provided a last argument.
                addConfig(prefix, es.getargv(3), es.getargv(4))
if not es.exists('command', 'addprefix'):
    es.regcmd('addprefix', 'server_manager/initializeManager','Syntax: addprefix <prefix> [script1;script2...;scriptn] [config1;config2...;confign] ["start/end"] [../cfg/server_manager?]')
    
def addConfig(prefix=None, config=None, whenWillItBeLoaded="start", useFolder=True):
    """Called upon command addconfig or by initializeManager. Check how many args is in here and do the relevant tasks."""
    if not prefix and not config:
        # If the command was called via a server command...
        prefix = es.getargv(1)
        if prefixDict.has_key(prefix):
            # If 4 args then they have not provided a last arg so it is True (the default value)
            if es.getargc() == 4:
                prefixDict[prefix].addConfig(es.getargv(2), es.getargv(3))
            else:
                prefixDict[prefix].addConfig(es.getargv(2), es.getargv(3), False)
        else:
            raise KeyError, "No prefix named %s" % prefix
    else:
        # Called by initializeManager...
        if prefixDict.has_key(prefix):
            if useFolder:
                # If useFolder is True, don't pass it
                prefixDict[prefix].addConfig(config, whenWillItBeLoaded)
            else:
                prefixDict[prefix].addConfig(config, whenWillItBeLoaded, False)
        else:
            raise KeyError, "No prefix named %s" % prefix
if not es.exists('command', 'addconfig'):
    es.regcmd('addconfig', 'server_manager/addConfig', 'Syntax: addconfig <prefix> ["config 1; config 2; config n"] ["start/end"] [0 to use ../cfg/ or blank for ../cfg/server_manager]')
    
def addScript(prefix=None, scripts=None):
    """Called upon command addscript or by initializeManager. Check how many args is in here and do the relevant tasks."""
    if not prefix and scripts:
        # Called via server command
        if prefixDict.has_key(prefix):
            prefixDict[es.getargv(1)].addScript(es.getargv(2))
        else:
            raise KeyError, "No prefix named %s" % prefix
    else:
        # Cllaed via initializeManager
        if prefixDict.has_key(prefix):
            prefixDict[prefix].addScript(scripts)
        else:
            raise KeyError, "No prefix named %s" % prefix
if not es.exists('command', 'addscript'):
    es.regcmd('addscript', 'server_manager/addScript', 'Syntax: addscript <prefix> ["script 1; script 2; ... script n"]')
    
class scriptManager(object):
    "Class to manage all prefix instances"
    def __init__(self, prefix):
        """Called upon instance initialization. Set the self. vars here"""
        self.prefix = {}
        self.prefix['prefix']  = prefix
        self.prefix['config']  = {}
        self.prefix['scripts'] = []
        
    def addConfig(self, configPath, whenWillItBeLoaded, useFolder=True):
        """Add a config file to the list"""
        # Folder will be ../cfg/server_manager/<config file>.cfg
        if configPath.count(';'):
            """Multiple files..."""
            configPath = map(lambda x: x.split(), configPath.split(';'))
            for instance in configPath:
                self.addConfig(instance, whenWillItBeLoaded, useFolder)
        else:
            """single file"""
            if not configPath.endswith('.cfg'):
                configPath += '.cfg'
            tempPath = '../cfg/'
            if useFolder:
                tempPath += 'server_manager/'
            tempPath += configPath
            self.prefix['config'][tempPath] = whenWillItBeLoaded
        
    def addScript(self, scriptName):
        """Add a script to the list"""
        if scriptName.count(';'):
            """multiple scripts"""
            scriptList = map(lambda x: x.split(), scriptName.split(';'))
            for instance in scriptList:
                self.addScript(instance)
        else:
            """single script"""
            self.prefix['scripts'].append(scriptName)
